abstract class myNumber{
	abstract public myNumber square();
	abstract public myNumber add(myNumber n);

	static myNumber addAll(myNumber [] nums){
		myNumber res = nums[0];
		for( int i=1; i<nums.length; i++)
			res = res.add(nums[i]);
		return res;
	}

	static void squareAll(myNumber [] nums){
		for( myNumber x : nums)
			System.out.println(x.square());
	}

	public static void main(String [] args){
		myNumber [] a = new myNumber [3];
		a[0] = new Rational(1,2);
		a[1] = new Rational(2,3);
		a[2] = new Rational(1,4);
		squareAll(a);
		System.out.println(addAll(a));
		a[2] = new Complex(1,2);
		squareAll(a);
		System.out.println(addAll(a));
	}
}

class Rational extends myNumber{
	int x,y;
	public Rational (int x, int y) {this.x=x; this.y=y;}
	public Rational square() { return new Rational(x*x,y*y);}
	public Rational add(myNumber r){ //Attn: no use defining add(Rational)
		Rational rr = (Rational)r;
		return new Rational(x*rr.y+y*rr.x,y*rr.y);
	}
	public String toString(){
		return "("+x+"/"+y+")";
	}
}

class Complex extends myNumber{
	double x,y;
	public Complex (double x, double y) {this.x=x; this.y=y;}
	public Complex square() {return new Complex(x*x-y*y,2*x*y); }
	public Complex add(myNumber r){ 
		Complex z = (Complex)r;
		return new Complex(x+z.x, y+z.y); 
	}
	public String toString(){
		return x+"i"+y;
	}
}

